/*
  Name: Errors.cpp
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This file contains the functions of the errors namespace,
	  that will show error messages for all kind of errors
*/

#include <string>
#include <allegro.h>
using namespace std;
#include "Errors.h"

void errors::fatalError(string message)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
    allegro_message(message.c_str());
    exit(0);
}

void errors::timerError()
{
	fatalError("Error001: Timer could not be initialised");
}

void errors::keyboardError()
{
	fatalError("Error002: No keyboarddriver found");
}

void errors::soundDriverError()
{
	fatalError("Error003: Sound driver could not be initialised");
}

void errors::graphicModeError()
{
	fatalError("Error004: Graphic mode couldn't be set");
}

void errors::createError()
{
	fatalError("Error005: Creating bitmap failed");
}


void errors::loadBitError(string name)
{
	fatalError(string("Error006: Loading bitmap \"") + name + string("\" failed"));
}

void errors::datafileError(string name)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error007: Loading datafile \"%s\" failed", name.c_str());
	exit(0);
}

void errors::sampleLoadError(string sampleName)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error008: Loading sample \"%s\" failed", sampleName.c_str());
	exit(0);
}

void errors::divBy0Error(string module)
{
	allegro_message("Error009: A division by 0 error was prevented in the following modul:\n\"%s\"", module.c_str());
}

void errors::mapLoadError(string mapName, string reason)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error010: Could not load map \"%s\" for the following reason:\n%s", mapName.c_str(), reason.c_str());
	exit(0);
}

void errors::tilesetLoadError(string mapName, string reason)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error011: Could not load tileset \"%s\" for the following reason:\n%s", mapName.c_str(), reason.c_str());
	exit(0);
}

void errors::scriptError(string reason)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error012: Script error:\n%s", reason.c_str());
	exit(0);
}

void errors::editorError(string reason)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
	allegro_message("Error013: Editor error:\n%s", reason.c_str());
	exit(0);
}

void errors::networkError(string reason)
{
	fatalError(string("Error014: Network error:\n") + reason);
}

void errors::multiplayerError(string description)
{
	fatalError(string("Error015: Multiplayer mode error:\n") + description);
}

void errors::mouseError()
{
	fatalError("Error016: Failed to initialise mouse");
}
