/*
  Name: SMPgame.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This is the server for multiplayer games.
    It contains one instance of a multiplayer game for the player
	playing on the server.
*/

#ifndef MP_GAME_CLASS_SERVER
#define MP_GAME_CLASS_SERVER

#include <libnet.h>
#include <string>
#include "packet.h"
#include "mapClass.h"
#include "CMPgame.h"
#include "requests.h"
#include "mpUnit.h"
#include "messageClass.h"

class serverMultiplayerGame
{
private:
	mapClass map;
	clientMultiplayerGame *game;
	messageClass *messages;

	const int maxPlayers;
	int playersJoined;
	const int minPlayers;
	const bool dedicatedServer;

	//Player instances
	mpUnit *players;
	//Spawn points
	int nSpawnPoints;
	float *spawnPointsX;
	float *spawnPointsY;
	int *spawnPointsDir;
	char *spawnPointsTeam;
	
	char gameType;
	//to prevent clients from expieriencing a time-out
	int messageNeededCountdown;

	bullet *bullets;
	NET_CONN *listenConn;
	
	packet pack;
	
	std::string mapname;
	int curSpawnPoint;

	void handleMoveRequest(float &newPosX, float &newPosY, float newPosX, float newPosY, int curPlayer);
	bool collides(int left1, int top1, int right1, int bottom1, int left2, int top2, int right2, int bottom2);
	void addBullets(bulletRequest *bReq);
	void explosion(bulletRequest bReq);
	void checkConnections();
	void serverBroadcast();
	void assignPosition(int player);
public:
	serverMultiplayerGame(std::string mapPath, int maxPlayers, int playersToStart, bool dedicated);
	int operator()();
	~serverMultiplayerGame();
};

#endif
