/*
  Name: messageClass.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: Message class - this class manages and stores messages revieved from
	  scripts, other players and the game itself.
*/

#ifndef MESSAGE_CLASS_MS
#define MESSAGE_CLASS_MS

#include <allegro.h>
#include <string>

class message : public std::string
{
private:
	bool displayed;
	int countdown;
public:
	message();
	void setCtd(int ctd);
	void poll();
	void draw(int posX, int posY, BITMAP *dest, FONT *useFont);
	bool isOld();
	void erase();
};

class messageClass
{
private:
	//The message buffer for newly received messages
	message recBuffer;

	//The messages that will be actually displayed
	message *displayedMessages;
	//The font that will be used
	FONT *stdFont, *boldFont;
	//The bitmap everything will be drawn onto
	BITMAP *dest;
	int size;
	int used;
	int plus;
	int posX;
	int maxVisible;
public:
	messageClass(int size, int maxVis, int stdX, FONT *mscFont, FONT *bldFont, BITMAP *drawTo);
	~messageClass();
	void sendText(std::string text);
	void sendInt(int value);
	void output();
	void draw(int initPosY, bool forceOutput = false);
	void poll();
	void showArchive();
};

#endif
