/*
  Name: mpUnit.cpp
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This class is used for the multiplayer mode on server side
*/

#include <allegro.h>
#include <string>
using namespace std;

#include "mpUnit.h"
#include "ElementaryFunctions.h"

mpUnit::mpUnit()
{
	active = false;
	points = 0;
	shootCooldown = 0;
	armor = maxArmor = 0;
	life = maxLife = 0;
	respawnTime = 0;
	phase = 0;
	connection = NULL;
	int i;
	for(i = 0; i < 4; ++i)
	    ammo[i] = 0;
}

mpUnit::~mpUnit()
{
	if(connection)
		net_closeconn(connection);
}

bool mpUnit::isActive()
{
	return active;
}

void mpUnit::getHit(int bulletType)
{
	//Armor piercing bullets or no armor left
	if(PIERCE[bulletType] || !armor)
	{
		life -= DAMAGE[bulletType];
	}
	else
	{
		int damageSub = int(float(DAMAGE[bulletType]) * 0.25);
		if(armor >= damageSub)
		{
			armor -= damageSub;
			life = life - DAMAGE[bulletType] + damageSub;
		}
		else
		{
			int damageLeft = DAMAGE[bulletType] - armor;
			armor = 0;
			life -= damageLeft;
		}
	}

	if(armor < 0)
		armor = 0;
	if(life < 0)
		life = 0;
}

bool mpUnit::isAlife()
{
	return life != 0;
}

void mpUnit::getConnected(NET_CONN *newconn)
{
	connection = newconn;
	points = 0;
	maxLife, life = 100;
	maxArmor, armor = 100;
	phase = 0;
	respawnTime = 64;
	shootCooldown = 0;

	int i;
	for(i = 0; i < 4; ++i)
	    ammo[1] = 0;
	active = true;
}

int mpUnit::receivePacket(char *buffer, int packetMaxSize)
{
	if(!connection)
		return 0;
	int length = 0;
	length = net_receive_rdm(connection, buffer, packetMaxSize);
	return length;
}

void mpUnit::leaveServer()
{
	if(connection)
		net_closeconn(connection);
	connection = 0;
	active = false;
}

NET_CONN *mpUnit::getConnection()
{
	return connection;
}

int &mpUnit::getPoints()
{
	return points;
}

int &mpUnit::getPhase()
{
	return phase;
}

