/*
  Name: playerUnit.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: The playerUnit class is derived from the Unit Class.
	  For each player in the game, a new instance is created.
*/

#ifndef PLAYERCLASS
#define PLAYERCLASS

#include <string>
#include "Unit.h"
#include "requests.h"

class playerUnit : public Unit
{
private:
	int *ammoAddress;

	int *lifeAddress, *armorAddress;
	int *pistolAllowed;
	
	bool isPistolAllowed();
	int &getLife();
	int &getArmor();
	int &getAmmo();
public:
	playerUnit();
	moveRequest *getMoveRequest(int playerPosX, int playerPosY);
	//moveRequest *getMoveRequest();
	bulletRequest *getBulletRequest();
	void addressInit(int *initAmmo, int *initLife, int *initArmor, int *pistolAddress);
	int getCurWeapon();
	int getAmmoleft();

	void load(float speed, int maxLife, int maxArmor, int armType, std::string spriteData);

	void draw(int cameraX, int cameraY);
	void getHit(int bulletType);

	bool isAlife();

	int getLifePercentage();
	int getArmorPercentage();
};

#endif
